Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class LibraryObjectDefinition

    java.lang.Object
      oracle.ifs.beans.LibraryObjectDefinition

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  PublicObjectDefinition, SchemaObjectDefinition, SystemObjectDefinition

    public class LibraryObjectDefinition

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

The LibraryObjectDefinition class is used to specify how to construct any Library Object. Generally, a user will use one of the subclasses of LibraryObjectDefinition, e.g. DocumentDefinition to construct a Document.

The main idea behind the use of Definition classes is to afford extensibility to the way objects are created, without having to subclass LibrarySession (on which all create methods are invoked). In order to create a new instance of any object, you first construct a LibraryObjectDefinition object (or one of its subclasses), set all of the desired attributes, and then invoke the appropriate method on LibrarySession (e.g. `createDocument`, `createFolder`, etc.) to actually create the object.

Most of the methods that exist on LibraryObjectDefinition do not rely on knowledge of a LibrarySession; hence they generally execute very quickly. Some of the attributes can be set either by name or by object (e.g. setting the ClassObject). In the case when the by-name variant is used, the lookup is not performed until the create method is invoked on LibrarySession, or unless the lookup is explicitly requested, for example by calling `resolveClassObject`. `resolveClassObject` requires a LibrarySession parameter, as a connected session is needed to perform the lookup.

As stated before, this class is generally not instantiated directly, as many subclasses are currently defined to create instances of the most common CM SDK classes. Still, this class implements two categories of settings that are generally used by all subclasses of LibraryObjectDefinition:

- To set the ClassObject to use for this instance. All instances that are created must have the ClassObject defined, although many of the subclasses define this by default (e.g. the FolderDefinition definition class sets the ClassObject to `"FOLDER"` by default). The caller can specify any valid subclass of the type of instance they are creating; for example, when using A FolderDefinition, a caller could specify a ClassObject of `"WORKFLOWFOLDER"`.
- To set any attribute by the attribute name. These methods are used in many of the subclasses to translate from specific `setFOO` methods to add the setting as an attribute name/value pair.

Note that many Classes of objects have special options that can be specified only by using the appropriate Definition Class. For example, specifying the content for a document you wish to create can only be done with a DocumentDefinition; there is no way to specify content using the LibraryObjectDefinition superclass.

See Also:
  Serialized Form
(Published)

Field Summary
`protected java.util.HashMap` | `m_Attributes`
`protected java.lang.String` | `m_ClassObjectName`
`protected AttributeValue` | `m_ClassObjectValue`
`protected java.util.HashMap` | `m_ContentSpecifications`
`protected java.util.HashMap` | `m_DefinitionLists`
`protected java.util.HashMap` | `m_Definitions`
`protected LibraryObjectDefinition` | `m_EnclosedDefinition`
`protected java.lang.Long` | `m_Id`
`protected java.util.HashMap` | `m_Options`
`protected boolean` | `m_ReadOnly`
`protected java.util.HashMap` | `m_ReferenceAttributes`
`protected LibrarySessionInterface` | `m_Session`
`protected java.util.HashMap` | `m_SystemOptions`

Constructor Summary
`LibraryObjectDefinition(LibrarySessionInterface session)` Construct a definition.
`LibraryObjectDefinition(LibrarySessionInterface session, java.lang.String className)` Construct a definition, explicitly capturing the session and setting the initial classobject.

Method Summary
`void` | `addDefinition(java.lang.String name, LibraryObjectDefinition value)` Add a definition to a definition list, which is identified by the specified name.
`void` | `addDefinitions(java.lang.String name, LibraryObjectDefinition[] values)` Add definitions to a definition list, which is identified by the specified name.
`void` | `addProperty(java.lang.String key, AttributeValue value)` Add a property definition to the definition.
`void` | `addPropertyDefinition(PropertyDefinition pDef)` Add a property definition to the definition.
`void` | `addPropertyDefinitions(PropertyDefinition[] pDefs)` Adds property definitions to the definition.
`protected void` | `captureSession(LibraryObject[] objs)` Capture the session setting from a set of LibraryObjects, if the session has not yet be specified in this instance.
`protected void` | `captureSession(LibraryObjectInterface obj)` Capture the session setting from a LibraryObject, if the session has not yet be specified in this instance.
`protected void` | `captureSession(LibrarySessionInterface session)` Capture the session setting from a LibarySession specified in some other operation, and hold it if our current session is null.
`LibraryObjectDefinition` | `clone(LibrarySessionInterface session)` Returns a clone of this LibraryObjectDefinition.
`static LibraryObjectDefinition` | `constructInstance(LibrarySessionInterface session, java.lang.Long classId)` Dynamically construct an instance from a fully qualified class name and a session instance
`static LibraryObjectDefinition` | `constructInstance(LibrarySessionInterface session, java.lang.String defClassName)` Dynamically construct an instance from a fully qualified class name and a session instance
`void` | `copyInto(LibraryObjectDefinition lodef)` Copy the contents of the target Definition into the specified Definition.
`AttributeValue` | `getAttribute(java.lang.String name)` Return an AttributeValue object that holds the value of the requested attribute.
`AttributeValue` | `getAttribute(java.lang.String name, boolean policyMode)` Return an AttributeValue object that holds the value of the requested attribute.
`AttributeValue[]` | `getAttributes()` Return array of Attribute values that were set for this new instance.
`AttributeValue[]` | `getAttributes(boolean policyMode)` Return array of Attribute values that were set for this new instance.
`AttributeValue[]` | `getAttributesSorted()` Return array of Attribute values sorted by the Attribute name used for each, so that a predictable ordering occurs.
`java.lang.Long` | `getClassId()` Return the Class Id, null if not persistent
`ClassObject` | `getClassObject()` Return the ClassObject for the new instance.
`AttributeValue` | `getClassObjectValue()` Return the ClassObject value for the new instance, as an AttributeValue.
`ContentStreamSerializer` | `getContentSpecification(java.lang.String name)` Return a Content specification
`java.lang.String[]` | `getContentSpecificationKeys()` Return array of Content specification keys
`AttributeValue` | `getCopiedObjectValue()` Get the Copied object value option.
`LibraryObjectDefinition` | `getDefinition(java.lang.String name)` Return a definition value.
`static java.lang.String` | `getDefinitionClassName(LibrarySessionInterface session, java.lang.Long classId)` Return the class name that would be used to construct a definition instance for the specified class ID.
`java.lang.String[]` | `getDefinitionKeys()` Return array of Definition keys
`java.lang.String[]` | `getDefinitionListKeys()` Return array of Definition List keys
`LibraryObjectDefinition[]` | `getDefinitions(java.lang.String name)` Return a set of definitions for a definition list, identified by the specified name.
`java.lang.Long` | `getId()` return the Id, null if not yet specified
`protected LibrarySession` | `getLibrarySession()` Get the bean-side session associated with this instance.
`java.lang.String` | `getName()` Get the Name set on this definition.
`java.lang.Object` | `getOption(java.lang.String name)` Return an option value.
`protected AttributeValue` | `getOptionAsAttributeValue(java.lang.String name)`
`java.lang.String[]` | `getOptionKeys()` Return array of option keys
`protected boolean` | `getPolicyMode()` Return indication as to whether or not the session context is in "policy mode"
`PropertyDefinition[]` | `getPropertyDefinitions()` Gets a list of property definitions that were added to the definition.
`ReferenceAttributeValue` | `getReferenceAttribute(java.lang.String name)` Return a reference attribute value.
`ReferenceAttributeValue[]` | `getReferenceAttributes()` Return array of reference attributes.
`S_LibraryObjectDefinition` | `getServerDefinition()` Return server-side definition from a bean definition.
`LibrarySessionInterface` | `getSession()` Get the session used in constructing this instance.
`protected S_LibrarySession` | `getSLibrarySession()` Get the server-side session used in constructing this instance.
`protected java.lang.String` | `getStringAttribute(java.lang.String name)` Return String value of an attribute value set with setAttribute.
`java.lang.Object` | `getSystemOption(java.lang.String name)` Return a system option value.
`protected AttributeValue` | `getSystemOptionAsAttributeValue(java.lang.String name)`
`protected java.lang.Boolean` | `getSystemOptionAsBoolean(java.lang.String name)`
`java.lang.String[]` | `getSystemOptionKeys()` Return array of system option keys
`LibraryObjectDefinition` | `getWriteableInstance()` Returns a a non-readonly instance.
`boolean` | `isReadOnly()` Returns indication as to whether the current instance cannot be changed.
`void` | `prepareForDefinitionObject(LibrarySession sess)` Perform any changes to the definition prior to storing it into a DefinitionObject.
`void` | `removeAttribute(java.lang.String name)` Removes an attribute setting for the new instance.
`void` | `removeContentSpecification(java.lang.String name)` Removes a ContentSpecification setting for the new instance.
`void` | `removeDefinition(java.lang.String name)` Removes a Definition setting for the new instance.
`void` | `removeDefinitions(java.lang.String name)` Add definitions to a definition list, which is identified by the specified name.
`void` | `removeOption(java.lang.String name)` Removes an option setting for the new instance.
`void` | `removePropertyDefinitions()` Removes all property definitions from this instance.
`void` | `removeReferenceAttribute(java.lang.String name)` Removes a reference attribute setting for the new instance.
`void` | `removeSystemOption(java.lang.String name)` Removes a system option setting for the new instance.
`void` | `reset()` Clear all updates made to this instance, except for session and ClassObject value settings.
`protected void` | `resolve(LibrarySession sess)` Resolve any settings that are object attributes set by Name.
`void` | `setAttribute(AttributeValue value)` Set an attribute for the new instance.
`void` | `setAttribute(AttributeValue value, boolean policyMode)` Set an attribute for the new instance.
`void` | `setAttribute(java.lang.String name, AttributeValue value)` Set an attribute for the new instance.
`void` | `setAttributeByUpperCaseName(java.lang.String attrkey, AttributeValue value)` Set an attribute for the new instance.
`void` | `setAttributeByUpperCaseName(java.lang.String attrkey, AttributeValue value, boolean policyMode)` Set an attribute for the new instance.
`void` | `setAttributePolicyMode(java.lang.String attrkey, boolean mode)` Change the policy mode of an existing Attribute setting.
`void` | `setAttributes(AttributeValue[] values)` Set a number of attributes for the new instance.
`void` | `setClassId(java.lang.Long classid)` set the ClassObject value by Id
`void` | `setClassname(java.lang.String className)` Set the ClassObject for the new instance, by using the class' name.
`void` | `setClassObject(ClassObject clss)` Set the ClassObject for the new instance.
`void` | `setClassObjectValue(AttributeValue av)` Set the ClassObject for the new instance.
`void` | `setContentSpecification(java.lang.String name, ContentStreamSerializer value)` Set a Content specification option for the new instance, identified by a name which distinguishes it from other Content specification options.
`void` | `setCopiedObjectValue(AttributeValue obj)` Set the copied object value option.
`void` | `setDefinition(java.lang.String name, LibraryObjectDefinition value)` Set a Definition option for the new instance, identified by a name which distinguishes it from other definition options.
`void` | `setDefinitions(java.lang.String name, LibraryObjectDefinition[] values)` Set the definitions of a definition list, which is identified by the specified name.
`void` | `setId(java.lang.Long id)` set the object Id
`void` | `setName(java.lang.String name)` Set the Name of the new instance.
`void` | `setOption(java.lang.String name, java.lang.Object value)` Set an option for the new instance.
`void` | `setReadOnly(boolean readonly)` Sets indication as to whether the current instance cannot be changed.
`void` | `setReferenceAttribute(ReferenceAttributeValue value)` Set a reference attribute for the new instance.
`void` | `setReferenceAttribute(java.lang.String name, ReferenceAttributeValue value)` Set a reference attribute for the new instance.
`void` | `setSession(LibrarySessionInterface session)` Set or reset the session used in constructing this instance.
`void` | `setSystemOption(java.lang.String name, java.lang.Object value)` Set a system option for the new instance.
`protected void` | `unresolve(LibrarySession sess)` Unresolve any settings from a resolved instance.
`protected LibrarySessionInterface` | `verifySession()` Throws if a session has not been specified.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_ClassObjectValue

    protected AttributeValue m_ClassObjectValue

(Unpublished)

### m_ClassObjectName

    protected java.lang.String m_ClassObjectName

(Unpublished)

### m_Attributes

    protected java.util.HashMap m_Attributes

(Unpublished)

### m_ReferenceAttributes

    protected java.util.HashMap m_ReferenceAttributes

(Unpublished)

### m_SystemOptions

    protected java.util.HashMap m_SystemOptions

(Unpublished)

### m_Options

    protected java.util.HashMap m_Options

(Unpublished)

### m_Definitions

    protected java.util.HashMap m_Definitions

(Unpublished)

### m_DefinitionLists

    protected java.util.HashMap m_DefinitionLists

(Unpublished)

### m_ContentSpecifications

    protected java.util.HashMap m_ContentSpecifications

(Unpublished)

### m_EnclosedDefinition

    protected LibraryObjectDefinition m_EnclosedDefinition

(Unpublished)

### m_ReadOnly

    protected boolean m_ReadOnly

(Unpublished)

### m_Id

    protected java.lang.Long m_Id

(Unpublished)

### m_Session

    protected transient LibrarySessionInterface m_Session

(Unpublished)

Constructor Detail

### LibraryObjectDefinition

    public LibraryObjectDefinition(LibrarySessionInterface session)
                            throws IfsException

  Construct a definition. No initial ClassObject is set.

  Parameters:
    `session` - the session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### LibraryObjectDefinition

    public LibraryObjectDefinition(LibrarySessionInterface session,
                                   java.lang.String className)
                            throws IfsException

  Construct a definition, explicitly capturing the session and setting the initial classobject.

  Parameters:
    `session` - the current session
    `className` - the initial class name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### isReadOnly

    public boolean isReadOnly()

  Description copied from class: `LibraryObjectDefinition`
  Returns indication as to whether the current instance cannot be changed. This will return false unless explicitly set readonly via the `setMutable` method.

  Returns:
    true if the instance cannot be explicitly changed
  (Published)

### setReadOnly

    public void setReadOnly(boolean readonly)
                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Sets indication as to whether the current instance cannot be changed.

  Parameters:
    `readonly` - indication of whether the instance should become readonly
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getWriteableInstance

    public LibraryObjectDefinition getWriteableInstance()
                                                 throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Returns a a non-readonly instance. Returns either this instance (if not readonly) or a cloned instance that encapsulates this instance if this instance is readonly. In this latter case, accessor methods on the clone will return the values set on the encapsulated instance. If further modified, the instance will override the settings on the encapsulated instance.

  Returns:
    true if the instance cannot be explicitly changed
  Throws:
    `IfsException`
  (Published)

### clone

    public LibraryObjectDefinition clone(LibrarySessionInterface session)
                                  throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Returns a clone of this LibraryObjectDefinition. The cloned instance will encapsulate the target instance, and refer to the same session and classobject value set on the target instance.

  Parameters:
    `session` - the session context
  Returns:
    a clone of this LibraryObjectDefinition.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### reset

    public void reset()
               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Clear all updates made to this instance, except for session and ClassObject value settings.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### copyInto

    public void copyInto(LibraryObjectDefinition lodef)
                  throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Copy the contents of the target Definition into the specified Definition.

  Parameters:
    `lodef` - The definition which gets set with the information contained in the target definition
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSession

    public LibrarySessionInterface getSession()

  Description copied from class: `LibraryObjectDefinition`
  Get the session used in constructing this instance.

  Returns:
    the session associated with this definition.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLibrarySession

    protected LibrarySession getLibrarySession()
                                        throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Get the bean-side session associated with this instance.

  Returns:
    the session associated with this definition.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSLibrarySession

    protected S_LibrarySession getSLibrarySession()
                                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Get the server-side session used in constructing this instance.

  Returns:
    the session associated with this definition.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setSession

    public void setSession(LibrarySessionInterface session)
                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set or reset the session used in constructing this instance. This is only used in two circumstances:
  - This instance was originally constructed with a null session, and now a session context is known
  - The session context used at construction time needs to be switched to a different session context. The only use for this currently is to switch the context from a server-side to a bean-side context, or vice versa.

  Parameters:
    `session` - the new session context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getId

    public java.lang.Long getId()
                         throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  return the Id, null if not yet specified

  Returns:
    the Id, null if not yet specified
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setId

    public void setId(java.lang.Long id)
               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  set the object Id

  Parameters:
    `id` - the Id
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getName

    public java.lang.String getName()
                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Get the Name set on this definition.

  Returns:
    The name set, or null if not set
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setName

    public void setName(java.lang.String name)
                 throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the Name of the new instance.

  Parameters:
    `name` - The name to be used for the new instance.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getPolicyMode

    protected boolean getPolicyMode()
                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return indication as to whether or not the session context is in "policy mode"

  Returns:
    the server-side definition.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getServerDefinition

    public S_LibraryObjectDefinition getServerDefinition()
                                                  throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return server-side definition from a bean definition. Ensure that the bean definition used to construct the server-side definition is writeable.

  Returns:
    the server-side definition.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setAttribute

    public void setAttribute(java.lang.String name,
                             AttributeValue value)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an attribute for the new instance. Each invocation of this method results in another attribute setting being added to an internal list. When definition is completely specified, it is passed to the appropriate LibrarySession.createXXXObject() method, where XXX is Public, Schema, or System. The createXXXObject method returns the newly persistent object.

  LibraryDefinitions are also used for update, free, and other repository operations as a way to specify options to the operation.

  To set an attribute to the null value (e.g., for the purpose of updating an object), you need to pass in an AttributeValue instance with its value set to null (see `AttributeValue.newNullAttributeValue`); note that this is not the same as passing null for the AttributeValue parameter. The latter removes the attribute from the internal list of specified values (i.e. behaves as if the attribute was never set in this definition).

  Parameters:
    `name` - The attribute name
    `value` - The attribute value.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttributeByUpperCaseName

    public void setAttributeByUpperCaseName(java.lang.String attrkey,
                                            AttributeValue value)
                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an attribute for the new instance. The caller ensures that the key specified is forced to uppercase. Each invocation of this method results in another attribute setting being added to an internal list.

  Parameters:
    `attrkey` - name The attribute name
    `value` - The attribute value.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttributeByUpperCaseName

    public void setAttributeByUpperCaseName(java.lang.String attrkey,
                                            AttributeValue value,
                                            boolean policyMode)
                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an attribute for the new instance.

  The caller ensures that the key specified is forced to uppercase. Each invocation of this method results in another attribute setting being added to an internal list. The policy mode is set explicitly.

  Parameters:
    `attrkey` - The attribute name
    `value` - The attribute value
    `policyMode` - The policy mode
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setAttribute

    public void setAttribute(AttributeValue value)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an attribute for the new instance. Each invocation of this method results in another attribute setting being added to an internal list.

  Parameters:
    `value` - The attribute value.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttribute

    public void setAttribute(AttributeValue value,
                             boolean policyMode)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an attribute for the new instance. Each invocation of this method results in another attribute setting being added to an internal list.

  Parameters:
    `value` - The attribute value
    `policyMode` - The policy mode.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setAttributes

    public void setAttributes(AttributeValue[] values)
                       throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a number of attributes for the new instance. The names of the attributes must be contained in each attribute value.

  Parameters:
    `values` - The attribute values.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttributePolicyMode

    public void setAttributePolicyMode(java.lang.String attrkey,
                                       boolean mode)
                                throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Change the policy mode of an existing Attribute setting.

  Has no effect if the specified attribute has not be specified on the target definition.

  Parameters:
    `attrkey` - The attribute name
    `mode` - The policy mode for the setting value.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getAttribute

    public AttributeValue getAttribute(java.lang.String name)
                                throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return an AttributeValue object that holds the value of the requested attribute.

  Parameters:
    `name` - the name of the AttributeValue to be returned
  Returns:
    the corresponding AttributeValue
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttribute

    public AttributeValue getAttribute(java.lang.String name,
                                       boolean policyMode)
                                throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return an AttributeValue object that holds the value of the requested attribute. Only return a value if the policy mode specified matches the mode that was in effect whent his attribute was set.

  Parameters:
    `name` - the name of the AttributeValue to be returned
    `policyMode` - the desired policy mode
  Returns:
    the corresponding AttributeValue
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getAttributes

    public AttributeValue[] getAttributes()
                                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Attribute values that were set for this new instance. The name of the attribute is set in the returned AttributeValues. The returned AttributeValue names are locked.

  Returns:
    AttributeValue array of the currently set attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributesSorted

    public AttributeValue[] getAttributesSorted()
                                         throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Attribute values sorted by the Attribute name used for each, so that a predictable ordering occurs. The returned AttributeValue names are locked.

  Returns:
    AttributeValue array of the currently set attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributes

    public AttributeValue[] getAttributes(boolean policyMode)
                                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Attribute values that were set for this new instance. Only return the values that were set with a policy mode that matches the mode specified. The returned AttributeValue names are locked.

  Parameters:
    `policyMode` - the desired policy mode
  Returns:
    AttributeValue array of the currently set attributes
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getStringAttribute

    protected java.lang.String getStringAttribute(java.lang.String name)

  Description copied from class: `LibraryObjectDefinition`
  Return String value of an attribute value set with setAttribute. Return null if the specified attribute name was not specified.

  Parameters:
    `name` - the name of the Attribute
  Returns:
    the corresponding String value
  (Unpublished)

### removeAttribute

    public void removeAttribute(java.lang.String name)
                         throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes an attribute setting for the new instance.

  Parameters:
    `name` - The name of the Attribute to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setReferenceAttribute

    public void setReferenceAttribute(java.lang.String name,
                                      ReferenceAttributeValue value)
                               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a reference attribute for the new instance.

  Parameters:
    `name` - The reference attribute name name
    `value` - The reference attribute value.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setReferenceAttribute

    public void setReferenceAttribute(ReferenceAttributeValue value)
                               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a reference attribute for the new instance. The name must be specified in the ReferenceAttributeValue.

  Parameters:
    `value` - The reference attribute value.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getReferenceAttribute

    public ReferenceAttributeValue getReferenceAttribute(java.lang.String name)

  Description copied from class: `LibraryObjectDefinition`
  Return a reference attribute value.

  Parameters:
    `name` - the name of the reference attribute
  Returns:
    the corresponding Value for the reference attribute
  (Unpublished)

### getReferenceAttributes

    public ReferenceAttributeValue[] getReferenceAttributes()
                                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of reference attributes.

  Returns:
    the array of reference attribute keys, or null if none.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### removeReferenceAttribute

    public void removeReferenceAttribute(java.lang.String name)
                                  throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes a reference attribute setting for the new instance.

  Parameters:
    `name` - The name of the reference attribute to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setSystemOption

    public void setSystemOption(java.lang.String name,
                                java.lang.Object value)
                         throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a system option for the new instance.

  Parameters:
    `name` - The option name
    `value` - The option value.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSystemOption

    public java.lang.Object getSystemOption(java.lang.String name)
                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return a system option value.

  Parameters:
    `name` - the name of the option
  Returns:
    the corresponding Value for the option
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSystemOptionKeys

    public java.lang.String[] getSystemOptionKeys()
                                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of system option keys

  Returns:
    array of system option keys
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### removeSystemOption

    public void removeSystemOption(java.lang.String name)
                            throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes a system option setting for the new instance.

  Parameters:
    `name` - The name of the system option to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSystemOptionAsBoolean

    protected java.lang.Boolean getSystemOptionAsBoolean(java.lang.String name)
                                                  throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getSystemOptionAsAttributeValue

    protected AttributeValue getSystemOptionAsAttributeValue(java.lang.String name)
                                                      throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### setOption

    public void setOption(java.lang.String name,
                          java.lang.Object value)
                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set an option for the new instance.

  Parameters:
    `name` - The option name
    `value` - The option value.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getOption

    public java.lang.Object getOption(java.lang.String name)
                               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return an option value.

  Parameters:
    `name` - the name of the option
  Returns:
    the corresponding Value for the option
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getOptionKeys

    public java.lang.String[] getOptionKeys()
                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of option keys

  Returns:
    array of option keys
  Throws:
    `IfsException` - if operation fails.
  (Published)

### removeOption

    public void removeOption(java.lang.String name)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes an option setting for the new instance.

  Parameters:
    `name` - The name of the option to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getOptionAsAttributeValue

    protected AttributeValue getOptionAsAttributeValue(java.lang.String name)
                                                throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getCopiedObjectValue

    public AttributeValue getCopiedObjectValue()
                                        throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Get the Copied object value option.

  Returns:
    The copied object value
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setCopiedObjectValue

    public void setCopiedObjectValue(AttributeValue obj)
                              throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the copied object value option.

  Parameters:
    `obj` - The copied object value
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setDefinition

    public void setDefinition(java.lang.String name,
                              LibraryObjectDefinition value)
                       throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a Definition option for the new instance, identified by a name which distinguishes it from other definition options.

  Parameters:
    `name` - The option name
    `value` - The Definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefinition

    public LibraryObjectDefinition getDefinition(java.lang.String name)
                                          throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return a definition value.

  Parameters:
    `name` - the name of the Definition
  Returns:
    the corresponding LibraryObjectDefinition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefinitionKeys

    public java.lang.String[] getDefinitionKeys()
                                         throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Definition keys

  Returns:
    array of Definition keys
  Throws:
    `IfsException` - if operation fails.
  (Published)

### removeDefinition

    public void removeDefinition(java.lang.String name)
                          throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes a Definition setting for the new instance.

  Parameters:
    `name` - The name of the Definition to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### addDefinition

    public void addDefinition(java.lang.String name,
                              LibraryObjectDefinition value)
                       throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Add a definition to a definition list, which is identified by the specified name.

  Parameters:
    `name` - The definition list name
    `value` - The Definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### addDefinitions

    public void addDefinitions(java.lang.String name,
                               LibraryObjectDefinition[] values)
                        throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Add definitions to a definition list, which is identified by the specified name.

  Parameters:
    `name` - The definition list name
    `values` - The Definitions to add to the list
  Throws:
    `IfsException` - if operation fails.
  (Published)

### removeDefinitions

    public void removeDefinitions(java.lang.String name)
                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Add definitions to a definition list, which is identified by the specified name.

  Parameters:
    `name` - The definition list name
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setDefinitions

    public void setDefinitions(java.lang.String name,
                               LibraryObjectDefinition[] values)
                        throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the definitions of a definition list, which is identified by the specified name.

  Parameters:
    `name` - The definition list name
    `values` - The Definitions that will become the new list
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefinitions

    public LibraryObjectDefinition[] getDefinitions(java.lang.String name)
                                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return a set of definitions for a definition list, identified by the specified name.

  Parameters:
    `name` - the name of the Definition list
  Returns:
    the corresponding set of LibraryObjectDefinitions, null if no definitions are present against the name
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefinitionListKeys

    public java.lang.String[] getDefinitionListKeys()
                                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Definition List keys

  Returns:
    array of Definition List keys
  Throws:
    `IfsException` - if operation fails.
  (Published)

### addProperty

    public void addProperty(java.lang.String key,
                            AttributeValue value)
                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Add a property definition to the definition.

  Delegates to addPropertyDefinition.

  Parameters:
    `key` - the property's key
    `value` - the property value
  Throws:
    `IfsException` - if the operation fails
  (Published)

### addPropertyDefinition

    public void addPropertyDefinition(PropertyDefinition pDef)
                               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Add a property definition to the definition.

  The property definition is added in such a way that results in the properties being added/replaced during create and update operations.

  Parameters:
    `pDef` - property definition
  Throws:
    `IfsException` - if the operation fails
  (Published)

### addPropertyDefinitions

    public void addPropertyDefinitions(PropertyDefinition[] pDefs)
                                throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Adds property definitions to the definition.

  The property definitions are added in such a way that results in the properties being added/replaced during create and update operations.

  Parameters:
    `pDefs` - property definitions
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPropertyDefinitions

    public PropertyDefinition[] getPropertyDefinitions()
                                                throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Gets a list of property definitions that were added to the definition.

  If addPropertyDefinition(s) method was not called on the current defintion prior to calling this method, then null will be returned.

  Returns:
    array of property definitions
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removePropertyDefinitions

    public void removePropertyDefinitions()
                                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes all property definitions from this instance.

  Throws:
    `IfsException`
  (Published)

### setContentSpecification

    public void setContentSpecification(java.lang.String name,
                                        ContentStreamSerializer value)
                                 throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set a Content specification option for the new instance, identified by a name which distinguishes it from other Content specification options.

  Parameters:
    `name` - The option name
    `value` - The Content specification
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentSpecification

    public ContentStreamSerializer getContentSpecification(java.lang.String name)
                                                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return a Content specification

  Parameters:
    `name` - the name of the Content specification
  Returns:
    the corresponding Content specification
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentSpecificationKeys

    public java.lang.String[] getContentSpecificationKeys()
                                                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return array of Content specification keys

  Returns:
    array of Content specification keys
  Throws:
    `IfsException` - if operation fails.
  (Published)

### removeContentSpecification

    public void removeContentSpecification(java.lang.String name)
                                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Removes a ContentSpecification setting for the new instance.

  Parameters:
    `name` - The name of the ContentSpecification to be removed.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setClassObjectValue

    public void setClassObjectValue(AttributeValue av)
                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the ClassObject for the new instance. All CM SDK subclasses of LibraryObjectDefinition have a default class. For example DocumentDefinition has a default class of DOCUMENT. You only need to call this method if you wish to specify a subclass of the default class (e.g., MySubclassOfDOCUMENT)

  Parameters:
    `av` - the AttributeValue that represents the desired LibraryObject Class
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setClassObject

    public void setClassObject(ClassObject clss)
                        throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the ClassObject for the new instance. All CM SDK subclasses of LibraryObjectDefinition have a default class. For example DocumentDefinition has a default class of DOCUMENT. You only need to call this method if you wish to specify a subclass of the default class (e.g., MySubclassOfDOCUMENT)

  Parameters:
    `clss` - the desired LibraryObject Class
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setClassId

    public void setClassId(java.lang.Long classid)
                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  set the ClassObject value by Id

  Parameters:
    `classid` - the Class Id
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setClassname

    public void setClassname(java.lang.String className)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Set the ClassObject for the new instance, by using the class' name. This name will not be validated until this instance is used in a `LibrarySession.createFOO()` method, or until resolveClassObject() is invoked.

  Parameters:
    `className` - the desired ClassObject Name
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClassObject

    public ClassObject getClassObject()
                               throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return the ClassObject for the new instance.

  Returns:
    the ClassObject to be used for the new instance.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getClassObjectValue

    public AttributeValue getClassObjectValue()
                                       throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return the ClassObject value for the new instance, as an AttributeValue.

  Returns:
    the ClassObject to be used for the new instance.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getClassId

    public java.lang.Long getClassId()

  Description copied from class: `LibraryObjectDefinition`
  Return the Class Id, null if not persistent

  Returns:
    the Class Id, null if not persistent
  (Unpublished)

### resolve

    protected void resolve(LibrarySession sess)
                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Resolve any settings that are object attributes set by Name. For example, if the ClassObject is set by name, resolve this into a ClassObject object. This method is extended by many of the subclasses (e.g. PublicObjectDefinition, ClassObject, etc.). If unable to resolve the names, throw an exception.

  Parameters:
    `sess` - The current session (needed to resolve the named attributes)
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### unresolve

    protected void unresolve(LibrarySession sess)
                      throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Unresolve any settings from a resolved instance. This restores the LibraryObjectDefinition instance to its original unresolved state, which will allow accessor methods (e.g. getClassname()) to work properly.

  Parameters:
    `sess` - The current session
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### prepareForDefinitionObject

    public void prepareForDefinitionObject(LibrarySession sess)
                                    throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Perform any changes to the definition prior to storing it into a DefinitionObject.

  Parameters:
    `sess` - The current session context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### verifySession

    protected LibrarySessionInterface verifySession()
                                             throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Throws if a session has not been specified.

  Returns:
    the session
  Throws:
    `IfsExceptionm` - if no session is specified
    `IfsException`
  (Unpublished)

### captureSession

    protected void captureSession(LibrarySessionInterface session)
                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Capture the session setting from a LibarySession specified in some other operation, and hold it if our current session is null.

  Parameters:
    `session` - a session
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

### captureSession

    protected void captureSession(LibraryObjectInterface obj)
                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Capture the session setting from a LibraryObject, if the session has not yet be specified in this instance.

  Parameters:
    `obj` - a LibraryObject
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

### captureSession

    protected void captureSession(LibraryObject[] objs)
                           throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Capture the session setting from a set of LibraryObjects, if the session has not yet be specified in this instance.

  Parameters:
    `objs` - an array of LibraryObject
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

### constructInstance

    public static LibraryObjectDefinition constructInstance(LibrarySessionInterface session,
                                                            java.lang.Long classId)
                                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Dynamically construct an instance from a fully qualified class name and a session instance

  Parameters:
    `session` - the session context
    `classId` - the ID of the ClassObject for which the definition is desired
  Returns:
    the new instance
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

### constructInstance

    public static LibraryObjectDefinition constructInstance(LibrarySessionInterface session,
                                                            java.lang.String defClassName)
                                                     throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Dynamically construct an instance from a fully qualified class name and a session instance

  Parameters:
    `session` - the session context
    `defClassName` - the fully qualified class name of the LibraryObjectDefinition instance to construct
  Returns:
    the new instance
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

### getDefinitionClassName

    public static java.lang.String getDefinitionClassName(LibrarySessionInterface session,
                                                          java.lang.Long classId)
                                                   throws IfsException

  Description copied from class: `LibraryObjectDefinition`
  Return the class name that would be used to construct a definition instance for the specified class ID.

  Parameters:
    `session` - the session context
    `classId` - the ID of the ClassObject for which the definition is desired
  Returns:
    the fully qualified class name for the Definition subclass, or null if the class Id specified was null, or if the Definition class could not be determined.
  Throws:
    `IfsException` - if no session is specified
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD